use crate::{
    errors::CvfsResult,
    secure_file::{ActiveFile, SecureFileHandler},
};
use multi_key_manager::file::File;
use std::{
    collections::HashMap,
    io::{Read, Result as IoResult},
};

pub struct Metadata {
    pub(crate) files: HashMap<String, FileInfo>,
}
impl Metadata {
    /// creates a new empty index
    pub fn empty() -> Self {
        Self {
            files: HashMap::new(),
        }
    } /*
      pub fn restore_from_read(input: &dyn Read) -> IoResult<Self> {
          todo!("Metadata::restore_from_read")
      }*/
    pub fn restore_from_slice(input: &[u8]) -> IoResult<Self> {
        todo!("Metadata::restore_from_slice")
    }

    /*pub fn create(&mut self, path: &str) -> CvfsResult<SecureFileHandler> {
        todo!("moved")
    }*/
}

/// Information stored per file, except the path
pub(crate) struct FileInfo {
    /// this exists if the file is already open
    active: Option<ActiveFile>,
    real_path: String,
    nonce: (),
}
impl FileInfo {
    pub fn new(path: &str) -> Self {
        // TODO validate the path?
        Self {
            active: None,
            real_path: path.to_owned(),
            nonce: (),
        }
    }
}

pub(crate) struct FileTag(usize);

#[cfg(test)]
mod tests {
    use super::*;
}
