use crate::{
    errors::CvfsResult,
    metadata::{FileTag, Metadata},
};
use multi_key_manager::file::File;
use std::{
    io::{Read, Write},
    sync::Weak,
};

/// an open active file
pub struct ActiveFile {
    id: FileTag,
    data: Vec<u8>,
    real_file: File,
}

pub struct SecureFileHandler {
    metadata: Weak<Metadata>,
    id: FileTag,
}
